//--------------------------------------------------------------------------------------
function byte Borrar();
// Borrar los seleccionados o en su defecto donde se encuentra el cursor.
// Devuelve '1' xito, '0' error.

private
	byte bSiNo=0;
	int iContador=0;
	byte bResultado=0;
	string sFicheroOrigen;
	string sMensajeOrigen[1];
	string sMensajeDestino[1];
	string sVentanaMensaje[0];
	string sArchivo;
	string sDirectorio="";
	
	int iVentanaProgresoCopia=0;
	int iTotalArchivosABorrar=0;
end

begin
	iDrawingZZ=-250;
	iTextZ=-380;
	Drawing_z(iDrawingZZ);
	Text_z=iTextZ;
	signal(ALL_PROCESS,s_freeze);
	dValorParcialDestino=0;
	//Si no hay nada que borrar, retorno 0.
	if (((pdirectorio[(Puntero+primerArchivo)].Name==".")or(pdirectorio[(Puntero+primerArchivo)].Name==".."))and
		iNTotalArchivosSeleccionados==0)
		return 0;
	end
	sVentanaMensaje[0]="Delete, are you sure?";
	bSiNo=VentanaSiNo(0,0,0,0,0,&sVentanaMensaje,1,"");
	if(!bSiNo)
		return 0;
	end
	// Hay algo que borrar.
	bAbortar=0;
	sMensajeOrigen[0]="Error en fichero origen: ";
	sMensajeOrigen[1]=sFicheroOrigen;
	//Abrimos una ventana de progreso de borrado.
	iVentanaProgresoCopia=VentanaProgresoCopia(0,0,0,0,0,iDrawingZZ-20,iTextZ-20);
	sProgresoOrigen="Prueba Origen";
	sProgresoDestino="Total:";
	iVentanaProgresoCopia.bRepintar=1;
	while (iVentanaProgresoCopia.bRepintar==1)
		frame;
	end
	while (!exists(iBarraOrigen))
		frame;
	end
	dValorOrigen=0;
	dValorDestino=0;
	dValorTotalDestino=iNTotalArchivosSeleccionados;
	if (dValorTotalDestino==0)
		dValorTotalDestino=1;
	end
	if (iNTotalArchivosSeleccionados>0) //Si hay algn archivo seleccionado.
		iContador=0;
		while (iContador<n_Archivos and !bAbortar)
			if (pDirectorio[iContador].selected)	// Si est seleccionado.
				if(!pDirectorio[iContador].directory)// Si es un archivo.
					if(!rm(sDirectorioEnCurso+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext))
						sMensajeOrigen[1]=pDirectorio[iContador].name+"."+pDirectorio[iContador].ext;
						VentanaMensaje(0,0,0,0,0,&sMensajeOrigen,2,"Error erasing: "+
						sDirectorioEnCurso+pDirectorio[iContador].name+"."+pDirectorio[iContador].ext);
						if (exists(iVentanaProgresoCopia))
							signal(iVentanaProgresoCopia,s_Kill_tree);
						end
						return 1;
					end
				else	// Es un directorio.
					if (pDirectorio[Puntero+primerArchivo].ext=="")
						if(BorraDirectorio(sDirectorioEnCurso+pDirectorio[iContador].name+chBarra))
							frame;
							cd(sDirectorioEnCurso);
						end
					else
						if(BorraDirectorio(sDirectorioEnCurso+pDirectorio[iContador].name
						+"."+pDirectorio[iContador].ext+chBarra))
							frame;
							cd(sDirectorioEnCurso);
						end
					end
				end
			end
			frame;
			iContador++;
		end
	else //Si no hay ningn archivo seleccionado borro el actual.
		if(!pDirectorio[(Puntero+primerArchivo)].directory)// Si es un archivo.
			if(!rm(sDirectorioEnCurso+pDirectorio[(Puntero+primerArchivo)].name+"."+pDirectorio[(Puntero+primerArchivo)].ext))
				sMensajeOrigen[1]=pDirectorio[(Puntero+primerArchivo)].name+"."+pDirectorio[(Puntero+primerArchivo)].ext;
				VentanaMensaje(0,0,0,0,0,&sMensajeOrigen,2,"Error erasing: "+
				sDirectorioEnCurso+pDirectorio[(Puntero+primerArchivo)].name+"."+pDirectorio[(Puntero+primerArchivo)].ext+chBarra);
				if (exists(iVentanaProgresoCopia))
					signal(iVentanaProgresoCopia,s_Kill_tree);
				end
				return 1;
			end
			bAbortar=0;
		else	// Es un directorio. Lo borro si no es .. o .
			dValorTotalDestino=CuantosArchivos(pdirectorio[(Puntero+primerArchivo)].Name);
			if ((pdirectorio[(Puntero+primerArchivo)].Name!=".")and(pdirectorio[(Puntero+primerArchivo)].Name!=".."))
				if (pDirectorio[Puntero+primerArchivo].ext=="")
					if(BorraDirectorio(sDirectorioEnCurso+pDirectorio[(Puntero+primerArchivo)].name+chBarra))
						frame;
						cd(sDirectorioEnCurso);
					end
				else
					if(BorraDirectorio(sDirectorioEnCurso+pDirectorio[(Puntero+primerArchivo)].name
					+"."+pDirectorio[Puntero+primerArchivo].ext+chBarra))
						frame;
						cd(sDirectorioEnCurso);
					end
				end
			end
		end
	end
	frame;
	if (exists(iVentanaProgresoCopia))
		signal(iVentanaProgresoCopia,s_Kill_tree);
	end
	frame;
	signal(ALL_PROCESS,s_wakeup);
	return 1;
end
		
//--------------------------------------------------------------------------------------
function byte BorraDirectorio(string sDirectorioOrigen)
// Borra recursivamente un directorio.
// Devuelve '1' xito, '0' error.

private 
	string sMensajeOrigen[1];
	string Archivo;
	string sDirectorio;
	dword dcien=100;
end

begin
	sMensajeOrigen[0]="Error borrando fichero origen: ";
	cd(sDirectorioOrigen);
	Archivo=glob("");
	Archivo=glob(mascara);
	while (Archivo!="" and bAbortar==0) /*buscamos un archivo cuyo nombre respete el patrn indicado*/
		if(!fileinfo.directory) // Es un archivo. Lo borro.
			sProgresoOrigen=fileinfo.name;
			if(!rm(fileinfo.name))
				sMensajeOrigen[1]=Fileinfo.name;
				VentanaMensaje(0,0,0,0,0,&sMensajeOrigen,2,"Error erasing: "+fileinfo.name);
				return 0;
			end
			dValorParcialDestino++;
			dValorDestino=((dValorParcialDestino)*dcien/(dValorTotalDestino));
		else
			if ((fileinfo.directory)and(fileinfo.name!=".")and(fileinfo.name!=".."))
				//Es un directorio que se puede borrar.
				BorraDirectorio(fileinfo.name+chBarra);
				Archivo=glob("");
			end
		end
		frame;
		Archivo=glob(mascara);
	end;
	sDirectorio=cd();
	chdir("..");
	glob("");
	dValorParcialDestino++;
	dValorDestino=((dValorParcialDestino)*dcien/(dValorTotalDestino));
	sProgresoOrigen=fileinfo.name;
	if(!bAbortar and rmdir(sDirectorio)!=0)
		sMensajeOrigen[1]=fileinfo.name;
		VentanaMensaje(0,0,0,0,0,&sMensajeOrigen,2,"Error erasing: "+sDirectorio);
		return 0;
	end
	return 1;
end
//------------------------------------------------------------------------------
function CuantosArchivos(string sOrigen)
// Devuelve el n de archivos en un directorio recursivamente.
private 
	int iNArchivos=0;
	int iContador=0;
	int iContador2=0;
	string Archivo;
end

begin
	cd(sOrigen);
	Archivo=glob("");
	Archivo=glob(mascara);
	while (Archivo!="") /*buscamos un archivo cuyo nombre respete el patrn indicado*/
		if ((fileinfo.directory)and(fileinfo.name!=".")and(fileinfo.name!=".."))
			iContador2=0;
			iNArchivos=iNArchivos+CuantosArchivos(fileinfo.name);
			Archivo=glob("");
			Archivo=glob(mascara);
			while (iContador2<iContador)
				Archivo=glob(mascara);
				iContador2++;
			end
		end
		iContador++;
		iNArchivos++;
		Archivo=glob(mascara);
	end;
	chdir("..");
	return iNArchivos;
end		
//--------------------------------------------------------------------------------------
