global
	string PantallaDirectorio[30]; // Pantalla virtual.
	int iLineasDirectorio=0;
	int iDirectorios=0;
	int iPunteroDirectorio=0;
	int iPrimerDirectorio=0;
	int iDrawIdeDirectorio=0;
	BarraDeslizante BarraDeslizanteDir;
	string sLineaSuperior="";
	fichero pointer pSoloDirectorio=0; // iPunteroDirectorio al directorio completo
end
//------------------------------------------------------------------------------
function string SelectDir(string sOrigen)
// Devuelve el directorio seleccionado.
private
	int iTamano=0;
	int iContador=0;
	int iContador2=0;
	string Archivo;
	string sDirectorio="";
	string sDirectorioEnCurso="";
	int iIdeLineaSuperior=0;
	int iIdeCaja=0;
	MarcoVentana iIdeMarcoVentana=0;
end

begin
	iDrawingZZ=iDrawingZZ-300;
	iTextZ=iTextZ-400;
	drawing_z(iDrawingZZ);
	text_z=iTextZ;
	signal(ALL_PROCESS,s_freeze);
	frame;
	sDirectorioEnCurso=cd();

	cd(sOrigen);
	cd("..");
	iLineasDirectorio=nLineas+2;
	//Dibujamos ventana.
	iIdeMarcoVentana=MarcoVentana(10,10,300,220,2," ");
	InicializarSoloDirectorio();
	iContador=0;
	//Escribimos linea azul.
	drawing_z(iDrawingZZ-30);
	drawing_color(rgb(10,36,106));
	iIdeCaja=draw_box(12,12,309,25);
	sLineaSuperior=substr(cd(),0,49);
	set_text_color(rgb(255,255,255));
	iIdeLineaSuperior=Write_var(iFuenteWhite,nSeparacionY+15,icontador*nAltoLinea+nSeparacionX-14,ALIGN_CENTER_LEFT,
	sLineaSuperior); //escribimos el nombre del archivo
	set_text_color(rgb(0,0,0));
	//Inicializando variables de pantalla.
	while (iContador<iLineasDirectorio)
		Write_var(iFuenteBlack,nSeparacionY+15,icontador*nAltoLinea+nSeparacionX,ALIGN_CENTER_LEFT,
		PantallaDirectorio[iContador]); //escribimos el nombre del archivo
		iContador++;
	end

	frame;
	bAbortar=0;
	if (PideDir() and bAbortar==0)
		sOrigen=cd();
		if (substr(sOrigen,len(sOrigen)-1,1)==chBarra)
			sOrigen=cd()+pSoloDirectorio[iPunteroDirectorio+iPrimerDirectorio].name+chBarra;
		else
			sOrigen=cd()+chBarra+pSoloDirectorio[iPunteroDirectorio+iPrimerDirectorio].name+chBarra;
		end	
	end
	bAbortar=0;

	//Limpiando.
	iContador=0;
	while (iContador<iLineasDirectorio)
		PantallaDirectorio[iContador]="";
		iContador++;
	end
	if(iDrawIdeDirectorio!=0)
		delete_draw(iDrawIdeDirectorio);
		iDrawIdeDirectorio=0;
	end
	if (pSoloDirectorio!=0)
		free(pSoloDirectorio);
		pSoloDirectorio=0;
	end
	delete_draw(iIdeCaja);
	delete_text(iIdeLineaSuperior);
	cd(sDirectorioEnCurso);
	if (exists(iIdeMarcoVentana))
		signal(iIdeMarcoVentana,s_kill_tree);
	end
	frame;
	signal(ALL_PROCESS,s_wakeup);
	frame;
	return sOrigen;
end
//------------------------------------------------------------------------------
function byte PideDir()
// Se mueve a travez de los directorios.
private

	int iPunteroDirectorioAntiguo[100];
	int Profundidad=0;
	int PrimerArchivoAntiguo[100];
	boton iIdeBotonSelectDir=0;
	string sTextoOK[0]="Select Dir";
	boton iIdeBotonCancel=0;
	string sTextoCancel[0]="Cancel";
	byte bSalida=0;

end

begin
	iIdeBotonSelectDir=boton(147,20,&sTextoOK,1,iFuenteBlack,4,rgb(212,208,200),0,3,0, iDrawingZZ-30, iTextZ);
	iIdeBotonSelectDir.iX=12;
	iIdeBotonSelectDir.iY=210;
	iIdeBotonSelectDir.bRepintar=1;
	iIdeBotonCancel=boton(150,20,&sTextoCancel,1,iFuenteBlack,4,rgb(212,208,200),0,3,0, iDrawingZZ-30, iTextZ);
	iIdeBotonCancel.iX=160;
	iIdeBotonCancel.iY=210;
	iIdeBotonCancel.bRepintar=1;
		repeat
			if (iIdeBotonSelectDir.bPulsado)
				while (iIdeBotonSelectDir.bPulsado)
					frame;
				end
				if (pSoloDirectorio[iPunteroDirectorio].name!="..")
					bSalida=1;
				end
			end
			if (iIdeBotonCancel.bPulsado)
				while (iIdeBotonCancel.bPulsado)
					frame;
				end
				bSalida=1;
				bAbortar=1;
			end

			if (jkeys_state[_JKEY_down])
				iPunteroDirectorio++;
				PintaSoloDirectorio();
				frame;
				timer[0]=0;
				while (timer[0]<30)
					frame; 
					if (!jkeys_state[_JKEY_DOWN ])
						timer[0]=50;
					end
				end
				while (jkeys_state[_JKEY_DOWN ])
					iPunteroDirectorio++;
					PintaSoloDirectorio();
					frame;
				end
				frame;
			end
			if (jkeys_state[_JKEY_UP ]) 
				iPunteroDirectorio--;
				PintaSoloDirectorio();
				frame;
				timer[0]=0;
				while (timer[0]<30)
					frame; 
					if (!jkeys_state[_JKEY_UP ])
						timer[0]=50;
					end
				end
				while (jkeys_state[_JKEY_UP ])
					iPunteroDirectorio--;
					PintaSoloDirectorio();
					frame;
				end
				frame;
			end
			IF (jkeys_state[_JKEY_LEFT ])
				iPunteroDirectorio=iPunteroDirectorio-iLineasDirectorio;
				PintaSoloDirectorio();
				frame;
				timer[0]=0;
				while (timer[0]<30)
					frame; 
					if (!jkeys_state[_JKEY_LEFT ])
						timer[0]=50;
					end
				end
				while (jkeys_state[_JKEY_LEFT ])
					iPunteroDirectorio=iPunteroDirectorio-iLineasDirectorio;
					PintaSoloDirectorio();
					frame;
				end
			END
			IF (jkeys_state[_JKEY_right])
				iPunteroDirectorio=iPunteroDirectorio+iLineasDirectorio;
				PintaSoloDirectorio();
				frame;
				timer[0]=0;
				while (timer[0]<30)
					frame; 
					if (!jkeys_state[_JKEY_right])
						timer[0]=50;
					end
				end
				while (jkeys_state[_JKEY_right])
					iPunteroDirectorio=iPunteroDirectorio+iLineasDirectorio;
					PintaSoloDirectorio();
					frame;
				end
			END
			if (jkeys_state[_JKEY_B])
				if (pSoloDirectorio[iPunteroDirectorio+iPrimerDirectorio].name=="..")
					chdir("..");
					InicializarSoloDirectorio();
					Profundidad--;
					IF (Profundidad<0)
						Profundidad=0;
						iPunteroDirectorio=0;
						iPrimerDirectorio=0;
					ELSE
						iPunteroDirectorio=iPunteroDirectorioAntiguo[Profundidad];
						iPrimerDirectorio=PrimerArchivoAntiguo[Profundidad];
					END
					PintaSoloDirectorio();
				else
					chdir(pSoloDirectorio[iPunteroDirectorio+iPrimerDirectorio].name);
					iPunteroDirectorioAntiguo[Profundidad]=iPunteroDirectorio;
					PrimerArchivoAntiguo[Profundidad]=iPrimerDirectorio;
					Profundidad++;
					InicializarSoloDirectorio();
					while (jkeys_state[_JKEY_B]) frame; end;
				end
				sLineaSuperior=substr(cd(),0,49);
				while (jkeys_state[_JKEY_B]) frame; end;
			end
			IF (jkeys_state[_JKEY_X])
				chdir("..");
				InicializarSoloDirectorio();
				Profundidad--;
				IF (Profundidad<0)
					Profundidad=0;
					iPunteroDirectorio=0;
					iPrimerDirectorio=0;
				ELSE
					iPunteroDirectorio=iPunteroDirectorioAntiguo[Profundidad];
					iPrimerDirectorio=PrimerArchivoAntiguo[Profundidad];
				END
				PintaSoloDirectorio();
				while (jkeys_state[_JKEY_X]) frame; end;
			END

			if (iPrimerDirectorio!=BarraDeslizanteDir.iValor)
				iPrimerDirectorio=BarraDeslizanteDir.iValor;
				PintaSoloDirectorio();
			end

			frame;
	until (jkeys_state[_JKEY_MENU] or bSalida)
	if (exists(iIdeBotonSelectDir))
		signal(iIdeBotonSelectDir,s_kill_tree);
	end
	frame;
	if (exists(iIdeBotonCancel))
		signal(iIdeBotonCancel,s_kill_tree);
	end
	frame;
	if (exists(BarraDeslizanteDir))
		signal(BarraDeslizanteDir,s_kill_tree);
	end
	frame;
	return bSalida;

end
//------------------------------------------------------------------------------
function InicializarSoloDirectorio()
//Inicializa variables.


private
	int iContador=0;
	BarraDeslizante BarraDeslizanteDirTemporal=0;
	string Archivo;
end

begin
	iPunteroDirectorio=0;    // Directorio que est actualmente seleccionado
	iPrimerDirectorio=0; // 1er directorio visible
	timer[0]=0;

	while (iContador<iLineasDirectorio)
		PantallaDirectorio[iContador]="";
		iContador++;
	end
	// A ver cuantos directorios encuentro
	Archivo=glob("");
	Archivo=glob("*.*");
	iDirectorios=0;
	while (Archivo!="") /*buscamos un archivo cuyo nombre respete el patrn indicado*/
		if (fileinfo.directory)
			iDirectorios++;
		end
		if (fileinfo.name==".")
			iDirectorios--;
		end
		Archivo=glob("*.*");
	end;

	//	Creo la barra deslizante.
	if (Exists(BarraDeslizanteDir))
		BarraDeslizanteDirTemporal=Barra_Deslizante(295,15,12+14,198-14,0,0,0,0,0,iDirectorios-iLineasDirectorio,0,
		iDrawingZZ-30, iTextZ);
		BarraDeslizanteDirTemporal.iSalto=10;
		frame;
		signal(BarraDeslizanteDir,s_kill_tree);
		frame;
		BarraDeslizanteDir=BarraDeslizanteDirTemporal;
		BarraDeslizanteDirTemporal=0;
	else
		BarraDeslizanteDir=Barra_Deslizante(295,15,12+14,198-14,0,0,0,0,0,iDirectorios-iLineasDirectorio,0,
		iDrawingZZ-30, iTextZ);
		BarraDeslizanteDir.iSalto=10;
	end

	// Reservando memoria para el directorio

	if (pSoloDirectorio!=0)
		Free(pSoloDirectorio);
	end
	pSolodirectorio=calloc(sizeof(tipofichero),iDirectorios+5);
	// Si alloc=0 ERROR
	if (pSoloDirectorio==0)
		write(0,0,0,0,"Error allocando memoria, ESC para salir");
		while(!jkeys_state[_JKEY_MENU]) frame; end
		exit();
	end
	// Llenamos la lista
	rellenaSoloDirectorio();
	PintaSoloDirectorio();
end

//-------------------------------------------------------------------------------------		
function rellenaSoloDirectorio()
// Devuelve iPunteroDirectorio al directorio relleno
private 
	int contador=0;
	string Archivo;
	int iContador2=0;
	int iLongitud=0;
	string sTrozos[9];
	int iTrozos;
end

begin
	Archivo=glob("");
	Archivo=glob("*.*");
	while (Archivo!="") /*buscamos un archivo cuyo nombre respete el patrn indicado*/
		if ((fileinfo.name!=".")and(fileinfo.directory))
			pSoloDirectorio[contador].name=fileinfo.name;
			contador++;
		end
		Archivo=glob("*.*");
	end;
	ksort(pSoloDirectorio,pSoloDirectorio[0].name,iDirectorios);
end		
//--------------------------------------------------------------------------------------
function pintaSoloDirectorio()
// Pinta al directorio relleno compuesto slo de directorios.
private 
	int contador=0;
	int contador2=0;
	string nombre;
	string sExt;
	int iMarco=1;
	int iAnchoDirectorio=242;
end

begin
	drawing_z(iDrawingZZ-30);
	if (iPunteroDirectorio>=iLineasDirectorio)
		iPrimerDirectorio=iPrimerDirectorio+iPunteroDirectorio-iLineasDirectorio+1;
		iPunteroDirectorio=iLineasDirectorio-1;
	end
	if (iPunteroDirectorio<0)
		iPrimerDirectorio=iPrimerDirectorio+iPunteroDirectorio;
		iPunteroDirectorio=0;
	end
	if (iPrimerDirectorio+iPunteroDirectorio>=iDirectorios)
		iPrimerDirectorio=iDirectorios-iLineasDirectorio;
		iPunteroDirectorio=iLineasDirectorio-1;
		if (iPunteroDirectorio>=iDirectorios)
			iPunteroDirectorio=iDirectorios-1;
		end
	end;
	if (iPrimerDirectorio<0)
		iPrimerDirectorio=0;
	end
	while ((contador<iLineasDirectorio) and ((contador+iPrimerDirectorio)<iDirectorios))
		nombre=pSoloDirectorio[(contador+iPrimerDirectorio)].name;
		if (text_Width(iFuenteBlack,nombre)>iAnchoDirectorio)
			contador2=0;
			while (text_width(iFuenteBlack,substr(nombre,0,len(nombre)-contador2))>iAnchoDirectorio)
					contador2++;
			end
			nombre=substr(nombre,0,len(nombre)-contador2)+"...";
		end
		if (contador==iPunteroDirectorio)
				if (iDrawIdeDirectorio!=0)
					delete_draw(iDrawIdeDirectorio);
					iDrawIdeDirectorio=0;
				end
				drawing_color(rgb(255,0,0));
				iDrawIdeDirectorio=draw_rect(14,contador*nAltoLinea+nSeparacionX-1-19+13,293,(contador+1)*nAltoLinea+nSeparacionX-1-19+13);
				BarraDeslizanteDir.iValor=iPrimerDirectorio;
				BarraDeslizanteDir.bRepintar=1;
		end
		PantallaDirectorio[contador]=("[ "+nombre+" ]"); /*escribimos el nombre del archivo*/
		contador++;
	end;
end

//------------------------------------------------------------------------------
